///////////////////////////////////////////////////////////////////////////////
//Standard-Map mit Möglichkeit zum zoomen, einzelne Trajektorien zu erzeugen 
//und um K zu verändern
////////////////////////////////////////////////////////////////////////////////

//Bildausschnitt zu Beginn: (Benötigt kein double, da einmalig)
float xU = 0; float xO = 1; 
float yU = 0  ; float yO = 1;
//Zwischenspeicher:
double  xUNeu, xONeu, yUNeu, yONeu,xAlt, yAlt, xNeu, yNeu;
double   xH, yH; 
PFont font;
int w = 800; int h = 800; 
int xK, yK; //Koordinaten der Punkte
int n, i, l, L, M; //Erläuterung im setup()
int f; //für die Farbe
double K;
boolean zeichnen, trajektZeichnen, schonTransparent;
PImage bild;
ArrayList<StartPunkt> startPunkte= new ArrayList<StartPunkt>();
///////////////////////////////////////////////////////////////////////////

void setup(){ 
   size(800, 800);
  background(0); 
  fill(255);
  smooth();
 //K = 0.971635; //erster Parameter der Map: Rotationszahl ist goldener Schnitt
  K=0.7;
  n= 5000;  //n...Anzahl der Iterationen
  L =50; //L Zufallsstartpunkte
  l = 0; //zählt die Zufallspunkte
  M = n; //Anzahl der Punkte auf einer ausgewählten Trajektorie
  for(l=0; l<L;l++){
     yH = random(0,1); xH =random(0,1);    
     StartPunkt neuerPunkt = new StartPunkt(xH,yH);
     startPunkte.add(neuerPunkt);
  }
  xUNeu = xU; xONeu = xO;
  yUNeu = yU; yONeu = yO;
  println("K = "+K,"xU = "+xUNeu,"xO = "+xONeu,"yU = "+yUNeu,"yO = "+yONeu);
//  AchsenZeichnen(); 
  zeichnen = true;
  trajektZeichnen = false;
  schonTransparent = false;
  bild = createImage(w,h,RGB);
  strokeWeight(1);
}
 
 void draw(){//Maps mit variierendem Parameter K zeichnen
   if(zeichnen){
    background(0);
       
    for(StartPunkt punkt: startPunkte){
        iteriere(punkt.getX(),punkt.getY(),n,K);           
     }
     f=0;     
     zeichnen  = false;
     if(!trajektZeichnen){
       zeichnen = false;        
       tint(255,120);//Bild wird teiltransparent, um die Trajektoerie besser zu sehen
       println("fertig");
     } 
   }  
 }
//Aus gegebenem Startpunkt (xH,yH) die folgenden n Punkte berechnen
////////////////////////////////////////////////////////
void iteriere(double xH, double yH, int N ,double K){  
  colorMode(HSB,256,256,256); 
  this.K =K;
  xAlt = xH; 
  yAlt = yH;
  point(xK,yK); 
  n =   N;
  stroke(color(f%256,255,255));
    
  while(i <=n){  //zur Abwechslung die auf 1 normierte Form:
       yNeu = (yAlt + K*Math.sin(2*Math.PI*xAlt)/(2*Math.PI)) % 1; 
       xNeu = (xAlt + yNeu) % 1;       
       if(xNeu <0) xNeu = xNeu +1;//damit  xNeu > 0
       if(yNeu <0) yNeu = yNeu +1;//damit  xNeu > 0
       yK = round( map((float)yNeu,yU,yO,h,0));                 
       xK = round (map((float)xNeu,xU,xO,0,w));  
       point(xK,yK);  
       xAlt = xNeu;
       yAlt = yNeu;
       i++; 
  }
   i=0;  f=f+5;  
}

void AchsenZeichnen(){
  stroke(255,100); 
  line(0,h/2,w,h/2);
  line(w/2,0,w/2,h);
}

//////////////////////////////////////////////////////
void mousePressed() { 
//Eine einzelne Trajektorie wird gezeichnet 
  if(mouseButton == LEFT){
      trajektZeichnen = true;
      if(!schonTransparent){
        image(bild,0,0);  
        schonTransparent = true;
      }   
      xH = map(mouseX,0,w,xU,xO); 
      yH = map(mouseY,0,h, yO,yU);
      //in die Startpunktmenge aufnehmen
      StartPunkt neuerPunkt = new StartPunkt(xH,yH);
      startPunkte.add(neuerPunkt);
      println("Startpunkt Trajektorie: "+xH,yH);
      //n = (int)(1.2*(float)n);
     // M = n;
      f = f +50;
      iteriere(xH,yH,M,K);
     
  }
//Die Stelle, auf die man klickt wird 10-fach vergrößert  
  if(mouseButton == RIGHT){
     for (int i = startPunkte.size() - 1; i >= 0; i--) {        
          startPunkte.remove(i);
     }    
      trajektZeichnen = false;
      background(0);
      xUNeu = map(mouseX,0,w,xU,xO)-(xO-xU)/10;
      xONeu = map(mouseX,0,w,xU,xO)+(xO-xU)/10;
      yUNeu = map(mouseY,0,h, yO,yU)-(yO-yU)/10;
      yONeu = map(mouseY,0,h, yO,yU)+(yO-yU)/10;
      xU =(float) xUNeu; xO =(float) xONeu; yU = (float)yUNeu; yO = (float)yONeu;
      println("xU = "+xUNeu,"xO = "+xONeu,"yU = "+yUNeu,"yO = "+yONeu);
      // L Startpunkte aus dem Zielgebiet:
      for(l=0; l<L;l++){
         yH = random(yU,yO); xH =random(xU,xO);    
         StartPunkt neuerPunkt = new StartPunkt(xH,yH);
         startPunkte.add(neuerPunkt);
      }
      if(n< 100000) {
        n = (int)(2*(float)n);//damit es nicht zu lange dauert!
        M = 4*n;
      }else M = 2*n;//nur die angeklickte Trajektorie bekommt mehr Punkte
      l=0;
      zeichnen = true;   
  } 
}
/////////////////////////////////////////////////////////////////

void keyPressed(){
  if(key == '+'){
      trajektZeichnen = false;
      background(0);
      l=0;
      K = K+0.01;
      zeichnen = true;
      println("K = "+K);
  }
    if(key == '-'){
      trajektZeichnen = false;
      background(0);
      l=0;
      K = K-0.01;
      zeichnen = true;
      println("K = "+K);
  }
}


////////////////////////////////////////////////////////////////////////////
//Klasse für die Punkte
//////////////////////////////////////////////////////////////////////////////
public class StartPunkt {

 //Attribute
 private double x;
 private double y;

 
 //Konstruktor
 public StartPunkt(double x, double y) {
   this.x = x;
   this.y = y;
 }

// Anfang Methoden
 public double getX() {
    return x;
 }
  
  public void setX(double x) {
    this.x = x;
  }
  
  public double getY() {
    return y;
  }
  
  public void setY(double y) {
    this.y = y;
  }
  
 
}
